<?php
namespace FiloBlu\ExtMysqlSearch\Helper;
use Magento\Framework\App\Config\ScopeConfigInterface;
use Magento\Catalog\Model\ResourceModel\Product\Attribute\CollectionFactory;

class Data
{

    const SEARCH_ORDER_ATTRIBUTE_ID ='catalog/search/sort_position_attribute';

    const SEARCH_ORDER_ATTRIBUTE_ENABLE = 'catalog/search/sort_attribute_yesno';

    const SORTING_DIRECTION = 'catalog/search/sorting_direction';
    /**
     * @var ScopeConfigInterface
     */
    private $config;
    /**
     * @var CollectionFactory
     */
    private $collectionFactory;


    /**
     * Data constructor.
     * @param ScopeConfigInterface $config
     * @param CollectionFactory $collectionFactory
     */
    public function __construct(
        ScopeConfigInterface $config,
        CollectionFactory $collectionFactory){
        $this->config = $config;
        $this->collectionFactory = $collectionFactory;
    }


    /**
     * @return bool|mixed
     */
    public function isSortOrderByAttributeEnable(){
        return $this->config->getValue(self::SEARCH_ORDER_ATTRIBUTE_ENABLE,\Magento\Store\Model\ScopeInterface::SCOPE_WEBSITE) ?? false;
    }

    /**
     * @return mixed
     */
    public function getSearchOrderAttribute(){
        return $this->config->getValue(self::SEARCH_ORDER_ATTRIBUTE_ID,\Magento\Store\Model\ScopeInterface::SCOPE_WEBSITE);
    }

    /**
     * @return mixed|string
     */
    public function getSortDirection(){
        return $this->config->getValue(self::SORTING_DIRECTION,\Magento\Store\Model\ScopeInterface::SCOPE_WEBSITE) ?? 'DESC';
    }


    /**
     * @return string
     */
    public function getSearchOrderAttributeLabel(){
        if($this->getSearchOrderAttribute()){
            $attribute = $this->collectionFactory->create()->addFieldToFilter('attribute_code',['eq'=>$this->getSearchOrderAttribute()]);
            return $attribute->getFirstItem()->getFrontendLabel();
        }else{
            return '';
        }

    }

}