<?php
namespace FiloBlu\ExtMysqlSearch\Plugin\Model;
use FiloBlu\ExtMysqlSearch\Helper\Data;
use Psr\Log\LoggerInterface;

class Config
{
    /**
     * @var Data
     */
    private $data;
    /**
     * @var LoggerInterface
     */
    private $logger;

    /**
     * Config constructor.
     * @param Data $data
     * @param LoggerInterface $logger
     */
    public function __construct(
        Data $data,
        LoggerInterface $logger){
        $this->data = $data;
        $this->logger = $logger;
    }

    /**
     * @param \Magento\Catalog\Model\Config $subject
     * @param $result
     * @return array
     */
    public function afterGetAttributeUsedForSortByArray(\Magento\Catalog\Model\Config $subject,$result){

        try{
            if($this->data->isSortOrderByAttributeEnable()){
                $newResults = [];
                foreach ($result as $attr){
                    if(is_object($attr)){
                        $newResults[] = $attr;
                    }else{
                        if($attr != $this->data->getSearchOrderAttributeLabel()){
                            $newResults [] = $attr;
                        }
                    }
                }
                $result = $newResults;
            }
            return $result;
        }catch (\Exception $e){
            $this->logger->critical($e->getMessage());
            return $result;
        }catch (\Throwable $t){
            $this->logger->critical($t->getMessage());
            return $result;
        }
    }


}